Gyoto::Photon::Refined Class Reference

Refine last step of integration in a Photon. More...

`#include <GyotoPhoton.h>`

Inheritance diagram for Gyoto::Photon::Refined:

## Public Types

typedef Gyoto::SmartPointer< Gyoto::SmartPointee > | Subcontractor_t(Gyoto::FactoryMessenger *, std::vector< std::string > const &)
| A subcontractor builds an object upon order from the Factory.

## Public Member Functions

| Refined (Photon *parent, size_t i, int dir, double step_max)
| Constructor.
virtual void | transmit (size_t i, double t)
| Update transmission both in *this and in *parent_.
virtual void | transmit (size_t i, Eigen::Matrix4d mat)
| Update transmission Matrix both in *this and in *parent_.
virtual void | transfer (double *Inu, double *Qnu, double *Unu, double *Vnu, Eigen::Matrix4d *Onu)
| Perform one step of polarized radiative transfert and update transmission matrix.
virtual Property const * | getProperties () const
| Get list of properties.
virtual std::string | className () const
| "Photon"
virtual std::string | className_l () const
| "photon"
Photon * | clone () const
| Cloner.
virtual double | getMass () const
| Return 0.
void | astrobj (SmartPointer< Astrobj::Generic >)
| Set Photon::object_.
SmartPointer< Astrobj::Generic > | astrobj () const
| Get Photon::object_.
void | metric (SmartPointer< Metric::Generic >)
SmartPointer< Metric::Generic > | metric () const
| Get metric.
void | spectrometer (SmartPointer< Spectrometer::Generic > spr)
| Set Photon::spectro_.
SmartPointer< Spectrometer::Generic > | spectrometer () const
| Get Photon::spectro_.
void | freqObs (double)
| Set Photon::freq_obs__.
double | freqObs () const
| Get Photon::freq_obs__.
void | nb_cross_eqplane (int)
| Set Photon::nb_cross_eqplane_.
int | nb_cross_eqplane () const
| Get Photon::nb_cross_eqplane_.
void | setInitialCondition (SmartPointer< Metric::Generic > gg, SmartPointer< Astrobj::Generic > obj, const double coord[8])
| Set or re-set the initial condition prior to integration.
void | setInitialCondition (SmartPointer< Metric::Generic > gg, SmartPointer< Astrobj::Generic > obj, const double coord[8], const double Ephi[4], const double Etheta[4])
| Set or re-set the initial condition prior to integration.
void | setInitialCondition (SmartPointer< Metric::Generic > gg, SmartPointer< Astrobj::Generic > obj, SmartPointer< Screen > screen, double d_alpha, double d_delta)
| Set or re-set the initial condition prior to integration.
void | setInitialCondition (SmartPointer< Metric::Generic > gg, const double coord[8], const int dir, double const Ephi[4], double const Etheta[4])
| Set or re-set the initial condition prior to integration.
void | setInitialCondition (SmartPointer< Metric::Generic > gg, const double coord[8], const int dir)
| Set or re-set the initial condition prior to integration.
int | hit (Astrobj::Properties *data=NULL)
| Integrate the geodesic.
double | findMin (Functor::Double_constDoubleArray *object, double t1, double t2, double &tmin, double threshold=DBL_MIN)
| Find minimum of photon–object distance.
void | findValue (Functor::Double_constDoubleArray *object, double value, double tinside, double &toutside)
| Find date for which the photon is at a given distance from the object.
virtual void | setParameters (FactoryMessenger *fmp)
| Main loop for parsing Properties from XML description.
void | resetTransmission ()
| Set transmission to 1 for each channel as well as scalar transmission.
void | resetTransmissionMatrix ()
| Set transmission matrix to identity matrix for each frequency.
double | getTransmission (size_t i) const
| Get transmission.
double const * | getTransmission () const
| Get Photon::transmission_.
Eigen::Matrix4d | getTransmissionMatrix (size_t i) const
| Get transmission matrix.
Eigen::Matrix4d const * | getTransmissionMatrix () const
| Get Photon::transmissionMatrix_.
double | getTransmissionMax () const
| Get maximum transmission;.
size_t | getImin () const
| Get imin_.
size_t | getImax () const
| Get imax_.
size_t | getI0 () const
| Get i0_.
void | initCoord (std::vector< double > const &)
std::vector< double > | initCoord () const
virtual void | setInitCoord (const double coord[8], int dir, double const Ephi[4], double const Etheta[4])
| Set Initial coordinate.
virtual void | setInitCoord (const double coord[8], int dir=0)
| Set Initial coordinate.
virtual void | setInitCoord (double const pos[4], double const vel[3], int dir=0)
| Set initial coordinate.
virtual void | setPosition (double const pos[4])
| Set initial 4-position.
virtual void | setVelocity (double const vel[3])
| Set initial 3-velocity.
void | reset ()
| Forget integration, keeping initial contition.
void | reInit ()
| Reset and recompute particle properties.
void | integrator (std::string const &type)
| Set the integrator.
std::string | integrator () const
| Describe the integrator used by state_.
void | integ31 (bool integ)
| Set the integrator kind to 3+1 or 4D.
bool | integ31 () const
| Get the kind of geodesic equation integrated by state_.
double | deltaMin () const
| Get delta_min_.
void | deltaMin (double h1)
| Set delta_min_.
double | deltaMax () const
| Get delta_max_.
virtual double | deltaMax (double const pos[8], double delta_max_external) const
void | deltaMax (double h1)
void | absTol (double)
| Set abstol_.
double | absTol () const
| Get abstol_.
void | relTol (double)
| Set reltol_.
double | relTol () const
| Get reltol_.
void | maxCrossEqplane (double)
| Set #maxCrosEqplane_.
double | maxCrossEqplane () const
| Get maxCrossEqplane_.
double | deltaMaxOverR () const
| Get delta_max_over_r_.
void | deltaMaxOverR (double t)
| Set delta_max_over_r_.
void | delta (const double delta)
| Expand memory slots for polarization vectors.
void | delta (double, const std::string &unit)
| Set delta_ in specified units.
double | delta () const
| Get delta_.
double | delta (const std::string &unit) const
| Get delta_ in specified units.
double | tMin () const
| Get tmin_.
double | tMin (const std::string &unit) const
| Get tmin_ in specified unit.
void | tMin (double tlim)
| Set tmin_.
void | tMin (double, const std::string &unit)
| Set tmin_ in specified unit.
void | adaptive (bool mode)
| Set adaptive_.
bool | adaptive () const
| Get adaptive_.
void | secondary (bool sec)
| Set secondary_.
bool | secondary () const
| Get secondary_.
void | parallelTransport (bool pt)
| Set parallel_transport_.
bool | parallelTransport () const
| Get parallel_transport_.
void | maxiter (size_t miter)
| Set maxiter_.
size_t | maxiter () const
| Get maxiter_.
double const * | getCst () const
| Returns the worldline's cst of motion (if any).
void | setCst (double const *cst, size_t const ncsts)
| Set Metric-specific constants of motion.
void | constantsOfMotion (std::vector< double > const cstv)
| Set Metric-specific constants of motion.
std::vector< double > | constantsOfMotion () const
| Return a copy of the Metric-specific constants of motion.
void | getInitialCoord (std::vector< double > &dest) const
| Get initial coordinates + base vectors.
void | getCoord (size_t index, Gyoto::state_t &dest) const
| Get coordinates+base vectors corresponding to index.
void | getCoord (size_t index, Gyoto::state_t &dest)
| Get coordinates+base vectors corresponding to index.
void | getCoord (double date, Gyoto::state_t &dest, bool proper=false)
| Get coordinates+base vectors corresponding to date dest[0].

void

getCoord (double const *const dates, size_t const n_dates, double *const x1dest, double *const x2dest, double *const x3dest, double *const x0dot=NULL, double *const x1dot=NULL, double *const x2dot=NULL, double *const x3dot=NULL, double *ep0=NULL, double *ep1=NULL, double *ep2=NULL, double *ep3=NULL, double *et0=NULL, double *et1=NULL, double *et2=NULL, double *et3=NULL, double *otime=NULL, bool proper=false)

| Get 8-coordinates for specific dates.
void | getCoord (double *x0, double *x1, double *x2, double *x3) const
| Get all computed positions.
void | getCartesianPos (size_t index, double dest[4]) const
| Get Cartesian expression of 4-position at index.
virtual void | xStore (size_t ind, state_t const &coord, double tau)
| Store coord at index ind.
virtual void | xStore (size_t ind, state_t const &coord)=delete
| Obsolete, update your code.
virtual void | xStore (size_t ind, double const coord[8])=delete
| Obsolete, update your code.
virtual void | xFill (double tlim, bool proper=false)
| Fill x0, x1... by integrating the Worldline from previously set inittial condition to time tlim.
size_t | get_nelements () const
| Get number of computed dates.
void | get_t (double *dest) const
| Get computed dates.
void | get_tau (double *dest) const
| Get computed proper times or values of the affine parameter.
void | getCartesian (double const *const dates, size_t const n_dates, double *const x, double *const y, double *const z, double *const xprime=NULL, double *const yprime=NULL, double *const zprime=NULL)
| Get the 6 Cartesian coordinates for specific dates.
void | get_xyz (double *x, double *y, double *z) const
| Get 3-position in cartesian coordinates for computed dates.
void | checkPhiTheta (double coord[8]) const
| Bring θ in [0,Π] and φ in [0,2Π].
void | getSkyPos (SmartPointer< Screen > screen, double *dalpha, double *ddellta, double *dD) const
| Get computed positions in sky coordinates.
void | get_dot (double *x0dot, double *x1dot, double *x2dot, double *x3dot) const
| Get computed 4-velocities.
void | get_prime (double *x1prime, double *x2prime, double *x3prime) const
| Get computed 3-velocities.
void | save_txyz (char *fichierxyz) const
| Save in a file.
void | save_txyz (char *const filename, double const t1, double const mass_sun, double const distance_kpc, std::string const unit, SmartPointer< Screen > sc=NULL)
| Save, converted.
void | incRefCount ()
| Increment the reference counter. Warning: Don't mess with the counter.
int | decRefCount ()
| Decrement the reference counter and return current value. Warning: Don't mess with the counter.
int | getRefCount ()
| Get the current number of references.
virtual bool | isThreadSafe () const
| Whether this class is thread-safe.
virtual void | set (Property const &p, Value val)
| Set Value of a Property.
virtual void | set (Property const &p, Value val, std::string const &unit)
| Set Value (expressed in unit) of a Property.
virtual void | set (std::string const &pname, Value val)
| Set Value of a Property.
virtual void | set (std::string const &pname, Value val, std::string const &unit)
| Set Value (expressed in unit) of a Property.
virtual Value | get (Property const &p) const
| Get Value of a Property.
virtual Value | get (std::string const &pname) const
| Get Value of a Property.
virtual Value | get (Property const &p, std::string const &unit) const
| Get Value of a Property, converted to unit.
virtual Value | get (std::string const &pname, std::string const &unit) const
| Get Value of a Property, converted to unit.
Property const * | property (std::string const pname) const
| Find property by name.
virtual void | fillProperty (Gyoto::FactoryMessenger *fmp, Property const &p) const
| Output a single Property to XML.
virtual void | fillElement (Gyoto::FactoryMessenger *fmp) const
| Fill the XML element for this Object.
virtual int | setParameter (std::string name, std::string content, std::string unit)
| Set parameter by name.
virtual void | setParameter (Gyoto::Property const &p, std::string const &name, std::string const &content, std::string const &unit)
| Set parameter by Property (and name).
std::string | describeProperty (Gyoto::Property const &p) const
| Format desrciption for a property.
void | help () const
| Print (to stdout) some help on this class.
virtual std::string | kind () const
| Get kind_.

## Static Public Member Functions

static SmartPointer< Photon > | Subcontractor (Gyoto::FactoryMessenger *)

## Public Attributes

| GYOTO_OBJECT_THREAD_SAFETY
| GYOTO_WORLDLINE
int | stopcond
| Whether and why integration is finished.

## Static Public Attributes

static GYOTO_OBJECT Property const | properties []

## Protected Member Functions

virtual void | xAllocate ()
| Allocate x0, x1 etc. with default size.
virtual void | xAllocate (size_t size)
| Allocate x0, x1 etc. with a specified size.
virtual size_t | xExpand (int dir)
| Expand x0, x1 etc... to hold more elements.
virtual void | xExpand (double *&x, int dir)
| Expand one array to hold more elements.
virtual void | eAllocate ()
| Allocate ep0_ ... et3_.
virtual void | eDeallocate ()
| Deallocate ep0_ ... et3_.
virtual void | eExpand (int dir)
virtual void | tell (Gyoto::Hook::Teller *)
| This is how a Teller tells.
virtual void | kind (const std::string)
| Set kind_.

## Protected Attributes

Photon * | parent_
| Parent Photon.
SmartPointer< Gyoto::Astrobj::Generic > | object_
| The astronomical target.
double | freq_obs_
| Photon's frequency in observer's frame.
double | transmission_freqobs_
| Integrated optical transmission.
Eigen::Matrix4d | transmissionMatrix_freqobs_
| Integrated optical transmission matrix (polarization).
SmartPointer< Spectrometer::Generic > | spectro_
| Observer's spectrometer.
double * | transmission_
| Integrated optical transmissions.
int | nb_cross_eqplane_
| Nb of crossings of equatorial plane z=0, theta=pi/2.
Eigen::Matrix4d * | transmissionMatrix_
| Integrated optical transmission matrix (polarization).
SmartPointer< Gyoto::Metric::Generic > | metric_
| The Gyoto::Metric in this part of the universe.
double * | tau_
| proper time or affine parameter
double * | x0_
| t or T
double * | x1_
| r or x
double * | x2_
| θ or y
double * | x3_
| φ or z
double * | x0dot_
| tdot or Tdot
double * | x1dot_
| rdot or xdot
double * | x2dot_
| θdot or ydot
double * | x3dot_
| φdot or zdot
double * | ep0_
double * | ep1_
| Coordinate of first base vector to parallel transport.
double * | ep2_
| Coordinate of first base vector to parallel transport.
double * | ep3_
| Coordinate of first base vector to parallel transport.
double * | et0_
| Coordinate of first base vector to parallel transport.
double * | et1_
| Coordinate of Second base vector to parallel transport.
double * | et2_
| Coordinate of Second base vector to parallel transport.
double * | et3_
| Coordinate of Second base vector to parallel transport.
size_t | x_size_
| Coordinate of Second base vector to parallel transport.
size_t | imin_
| Minimum index for which x0_, x1_... have been computed.
size_t | i0_
| Index of initial condition in array.
size_t | imax_
| Maximum index for which x0_, x1_... have been computed.
bool | adaptive_
| Whether integration should use adaptive delta.
bool | secondary_
| Experimental: choose 0 to compute only primary image.
bool | parallel_transport_
| Whether to parallel transport a local triad.
double | delta_
| Initial integrating step.
double | tmin_
| Time limit for the integration (geometrical units).
double * | cst_
| Worldline's csts of motion (if any).
size_t | cst_n_
| Number of constants of motion.
int | wait_pos_
| Hack in setParameters().
double * | init_vel_
| Hack in setParameters().
size_t | maxiter_
| Maximum number of iterations when integrating.
double | delta_min_
| Minimum integration step for the adaptive integrator.
double | delta_max_
| Maximum integration step for the adaptive integrator.
double | delta_max_over_r_
| Numerical tuning parameter.
double | abstol_
| Absolute tolerance of the integrator.
double | reltol_
| Absolute tolerance of the integrator.
double | maxCrossEqplane_
| Maximum number of crossings of equatorial plane.
SmartPointer< Worldline::IntegState::Generic > | state_
| An object to hold the integration state.
std::string | kind_
| The "kind" that is output in the XML entity.
std::vector< std::string > | plugins_
| The plug-ins that needs to be loaded to access this instance's class.

## Private Member Functions

void | _allocateTransmission ()
| Allocate Photon::transmission_.
void | _allocateTransmissionMatrix ()

## Private Attributes

int | refCount
| Reference counter.
pthread_mutex_t | mutex_
| A mutex.

## Detailed Description

Refine last step of integration in a Photon.

The integration step of a Photon's geodesic is adaptive. This is computationally efficient, but sometimes it is necessary to get the position of a Photon with a finer step. Gyoto::ComplexAstrobj::Impact() is a typical use case.

A Refined photon is linked to its parent. In particular, care is taken so that the parent's to update the parent's transmissions whenever the Refined transmissions are touched.

Don't use this class blindly: what's guaranteed to work is what is used in Gyoto::ComplexAstrobj::Impact().

XML description corresponding to this class is <Photon/>. It supports all the parameters supported by the Gyoto::Worldline class plus an optional <Astrobj/> section to attach a instance of a Gyoto::Astrobj::Generic sub-class.

## Member Typedef Documentation

## Subcontractor_t

typedef Gyoto::SmartPointer< Gyoto::SmartPointee > Gyoto::SmartPointee::Subcontractor_t(Gyoto::FactoryMessenger *, std::vector< std::string > const &)

inherited

A subcontractor builds an object upon order from the Factory.

Various classes need to provide a subcontractor to be able to instantiate themselves upon order from the Factory. A subcontractor is a function (often a static member function) which accepts a pointer to a FactoryMessenger as unique parameter, communicates with the Factory using this messenger to read an XML description of the object to build, and returns this objet. SmartPointee::Subcontractor_t* is just generic enough a typedef to cast to and from other subcontractor types: Astrobj::Subcontractor_t, Metric::Subcontractor_t, Spectrum::Subcontractor_t. A subcontractor needs to be registered using the relevant Register() function: Astrobj::Register(), Metric::Register(), Spectrum::Register().

## Member Function Documentation

## checkPhiTheta()

void Gyoto::Worldline::checkPhiTheta | ( | double | coord[8] | ) | const

inherited

Bring θ in [0,Π] and φ in [0,2Π].

checkPhiTheta() Modifies coord if the corrdinates are spherical-like so that coord[2]=theta is in [0,pi] and coord[3]=phi is in [0,2pi]. Important to use in all astrobj in spherical coordinates to prevent "z-axis problems".

## className()

virtual std::string Gyoto::Photon::className | ( |  | ) | const

virtual inherited

"Photon"

Reimplemented from Gyoto::Worldline.

## className_l()

virtual std::string Gyoto::Photon::className_l | ( |  | ) | const

virtual inherited

"photon"

Reimplemented from Gyoto::Worldline.

## constantsOfMotion() [1/2]

std::vector< double > Gyoto::Worldline::constantsOfMotion | ( |  | ) | const

inherited

Return a copy of the Metric-specific constants of motion.

This function return a copy of the constants of motion. getCst() can be used to retrieve a pointer to the actual array used internally which is slightly more efficient for read-only access.

## constantsOfMotion() [2/2]

void Gyoto::Worldline::constantsOfMotion | ( | std::vector< double > const | cstv | ) |

inherited

Set Metric-specific constants of motion.

The will (re)allocate Worldline::cst_, copy cst into it, and set Worldline::cst_n_.

This is the same as getCst using a vector instead of a C-style array.

## delta()

void Gyoto::Worldline::delta | ( | const double | delta | ) |

inherited

Expand memory slots for polarization vectors.

Assignment to another Worldline Set delta_

## deltaMax() [1/2]

virtual double Gyoto::Worldline::deltaMax | ( | double const | pos[8],
|  | double | delta_max_external ) const

virtual inherited

Get delta max at a given position

Parameters

  [in] | pos | 4-position
  [in] | delta_max_external | external constraint on delta_max

Returns
  the smallest value between delta_max_, delta_max_external, and R*delta_max_over_r_ where R is pos[1] in spherical coordinates and max(x1, x2, x3) in Cartesian coordinates.

Reimplemented in Gyoto::Astrobj::EquatorialHotSpot, and Gyoto::Astrobj::Star.

## deltaMax() [2/2]

void Gyoto::Worldline::deltaMax | ( | double | h1 | ) |

inherited

Set delta_max_

## describeProperty()

std::string Gyoto::Object::describeProperty | ( | Gyoto::Property const & | p | ) | const

inherited

Format desrciption for a property.

Returns a string containing the name(s) and type of the property, as well as whether it supports unit.

## eAllocate()

virtual void Gyoto::Worldline::eAllocate | ( |  | ) |

protected virtual inherited

Allocate ep0_ ... et3_.

Allocate memory for polarization vectors

## eDeallocate()

virtual void Gyoto::Worldline::eDeallocate | ( |  | ) |

protected virtual inherited

Deallocate ep0_ ... et3_.

Deallocate memory for polarization vectors

## eExpand()

virtual void Gyoto::Worldline::eExpand | ( | int | dir | ) |

protected virtual inherited

Call xExpand(double * &x, int dir) on #ep0_, ep1_ etc.

## fillElement()

virtual void Gyoto::Object::fillElement | ( | Gyoto::FactoryMessenger * | fmp | ) | const

virtual inherited

Fill the XML element for this Object.

The base implementation simply calls fillProperty() for each Property defined for the Object.

Derived classes should avoid overriding fillElement(). It may make sense occasionally, e.g. to make sure that the metric is output first.

To customize how a given Property is rendered, it is better to override fillProperty().

If this method is overridden, the implementation should in general call fillElement() on the direct base.

Reimplemented in Gyoto::Astrobj::Complex, Gyoto::Metric::Complex, Gyoto::Scenery, and Gyoto::Spectrometer::Complex.

## fillProperty()

virtual void Gyoto::Object::fillProperty | ( | Gyoto::FactoryMessenger * | fmp,
|  | Property const & | p ) const

virtual inherited

Output a single Property to XML.

The base implementation decides what to do based on the p.type. The format matches how setParameters() an setParameter() would interpret the XML descition.

Overriding this method should be avoided, but makes sense in some cases (for instance Screen::fillProperty() selects a different unit for Distance based on its magnitude, so that stellar sizes are expressed in solar radii while smaller sizes can be expressed in meters and larger sizes in parsecs).

Overriding implementation should fall-back on calling the implementation in the direct parent class:

class A: public Object {};
class B: public A {
using B::setParameter;
virtual void fillProperty(Gyoto::FactoryMessenger *fmp,
Property const &p) const ;
};
void B::fillProperty(Gyoto::FactoryMessenger *fmp,
Property const &p) const {
if (name=="Duff") fmp->doSomething();
else A::fillProperty(fmp, p);
}
Gyoto::FactoryMessenger
Factory / SmartPointee::Subcontractor_t interface.
Definition GyotoFactoryMessenger.h:92
Gyoto::Object::fillProperty
virtual void fillProperty(Gyoto::FactoryMessenger *fmp, Property const &p) const
Output a single Property to XML.
Gyoto::Object::Object
Object(std::string const &kind)
Constructor setting kind.
Gyoto::Property
Property that can be set and got using standard methods.
Definition GyotoProperty.h:608

Reimplemented in Gyoto::Astrobj::DirectionalDisk, Gyoto::Astrobj::Disk3D, Gyoto::Astrobj::DynamicalDisk, Gyoto::Astrobj::EquatorialHotSpot, Gyoto::Astrobj::NeutronStarModelAtmosphere, Gyoto::Astrobj::PatternDisk, Gyoto::Astrobj::PolishDoughnut, Gyoto::Astrobj::Star, Gyoto::Astrobj::XillverReflection, Gyoto::Metric::Shift, Gyoto::Scenery, Gyoto::Screen, and Gyoto::Spectrometer::Uniform.

## findMin()

double Gyoto::Photon::findMin | ( | Functor::Double_constDoubleArray * | object,
|  | double | t1,
|  | double | t2,
|  | double & | tmin,
|  | double | threshold = DBL_MIN )

inherited

Find minimum of photon–object distance.

Return the minimum of (*object)(this->getCoord()) between t1 and t2. The date of this minimum is returned in tmin.

Parameters

  [in] | object | the distance to minimize is given by object->operator()(). This method is in particular implemented by the subclasses of Astrobj::Standard.
  [in] | t1 | date
  [in] | t2 | date
  [out] | tmin | on output, date correspondig to the minimum
  [in] | threshold | stop searching for a minimum if a value < threshold is found (very often, we just want to find a date below the threshold, not the accurate minimum).

## findValue()

void Gyoto::Photon::findValue | ( | Functor::Double_constDoubleArray * | object,
|  | double | value,
|  | double | tinside,
|  | double & | toutside )

inherited

Find date for which the photon is at a given distance from the object.

Parameters

  [in] | object | Object, must implement operator() (e.g. Astrobj::Standard, ThinDisk::Standard)
  [in] | value | The value to find
  [in] | tinside | A date for which object->Astrobj::operator()(Photon::getCoord()) is < value
  [in,out] | toutside | On input: a date for which object->Astrobj::operator()(Photon::getCoord()) is > value. on output, (*object)(getCoord(toutside)) is < value, very close to value. toutside is closer to tinside on output than on input.

## getCartesian()

void Gyoto::Worldline::getCartesian | ( | double const *const | dates,
|  | size_t const | n_dates,
|  | double *const | x,
|  | double *const | y,
|  | double *const | z,
|  | double *const | xprime = NULL,
|  | double *const | yprime = NULL,
|  | double *const | zprime = NULL )

inherited

Get the 6 Cartesian coordinates for specific dates.

The 6 coordinates (x, y, z, dx/dt, dy/dt, dz/dt) will be computed using the integrator and interpolated if necessary, so they will be as accurate as possible. Transforming to Cartesian coordinates is not necessarily meaningful.

Parameters

  [in] | dates | List of dates for which the coordinates are to be computed;
  [in] | n_dates | Number of dates to compute ;
  [out] | x,y,z,xprime,yprime,zprime | Arrays in which to store the result. These pointer may be set to NULL to retrieve only part of the information. Else, they must be pre-allocated.

## getCoord() [1/5]

void Gyoto::Worldline::getCoord | ( | double * | x0,
|  | double * | x1,
|  | double * | x2,
|  | double * | x3 ) const

inherited

Get all computed positions.

Get all the pre-computed 8 coordinates (e.g. thanks to a prior call to xFill()) of this worldline.

## getCoord() [2/5]

void Gyoto::Worldline::getCoord | ( | double const *const | dates,
|  | size_t const | n_dates,
|  | double *const | x1dest,
|  | double *const | x2dest,
|  | double *const | x3dest,
|  | double *const | x0dot = NULL,
|  | double *const | x1dot = NULL,
|  | double *const | x2dot = NULL,
|  | double *const | x3dot = NULL,
|  | double * | ep0 = NULL,
|  | double * | ep1 = NULL,
|  | double * | ep2 = NULL,
|  | double * | ep3 = NULL,
|  | double * | et0 = NULL,
|  | double * | et1 = NULL,
|  | double * | et2 = NULL,
|  | double * | et3 = NULL,
|  | double * | otime = NULL,
|  | bool | proper = false )

inherited

Get 8-coordinates for specific dates.

The coordinates will be computed using the integrator, so they will be as accurate as possible. Some heuristics are used to speed up the process and it is presumably faster to call this routine with a sorted list of dates. The line will be integrated further as required. An error will be thrown if it is not possible to reach a certain date.

Parameters

  [in] | dates | the list of dates for which the coordinates are to be computed in proper time or affine parameter if #proper is true or in coordinate time if #proper is false (default);
  [in] | n_dates | the number of dates to compute ;
  [out] | x1dest,x2dest,x3dest,x0dot,x1dot,x2dot,x3dot | arrays in which to store the result. These pointer may be set to NULL to retrieve only part of the information. They must be pre-allocated.
  [out] | ephi0,ephi1,ephi2,ephi3,etheta0,etheta1,etheta2,etheta3 | arrays in which to store the ephi and etheta (parallel transport case). These pointer may be set to NULL to retrieve only part of the information. They must be pre-allocated.
  [out] | otime | array in which to store the other time: coordinate time if #proper, else proper time or affine parameter.
  [in] | proper | bool: whether #dates is proper time (or affine parameter) or coordinate time.

## getCoord() [3/5]

void Gyoto::Worldline::getCoord | ( | double | date,
|  | Gyoto::state_t & | dest,
|  | bool | proper = false )

inherited

Get coordinates+base vectors corresponding to date dest[0].

Depending on the value of parallel_transport_, get position (xi_), velocity (xidot_) and possibly other triad vectors (epi_ and eti_). coord is resized to the right number of elements.

## getCoord() [4/5]

void Gyoto::Worldline::getCoord | ( | size_t | index,
|  | Gyoto::state_t & | dest )

inherited

Get coordinates+base vectors corresponding to index.

We need this non-const implementation to allow the const, size_t and the non-const, double implementations to coexist.

## getCoord() [5/5]

void Gyoto::Worldline::getCoord | ( | size_t | index,
|  | Gyoto::state_t & | dest ) const

inherited

Get coordinates+base vectors corresponding to index.

Depending on the value of parallel_transport_, get position (xi_), velocity (xidot_) and possibly other triad vectors (epi_ and eti_). coord is resized to the right number of elements.

## getCst()

double const * Gyoto::Worldline::getCst | ( |  | ) | const

inherited

Returns the worldline's cst of motion (if any).

Return pointer to array holding the previously set Metric-specific constants of motion.

This function returns a pointer to the actual storage location and should be handled with care. std::vector<double> Worldline:constantsOfMotion() const provides a convenient way to retrieve a copy of the content.

## getInitialCoord()

void Gyoto::Worldline::getInitialCoord | ( | std::vector< double > & | dest | ) | const

inherited

Get initial coordinates + base vectors.

Depending on the size of dest and on the value of parallel_transport_, get position (xi_), velocity (xidot_) and possibly other triad vectors (epi_ and eti_).

## getMass()

virtual double Gyoto::Photon::getMass | ( |  | ) | const

virtual inherited

Return 0.

Implements Gyoto::Worldline.

## getProperties()

virtual Property const * Gyoto::Photon::getProperties | ( |  | ) | const

virtual inherited

Get list of properties.

This method is declared automatically by the GYOTO_OBJECT macro and defined automatically by the GYOTO_PROPERTY_END macro.

Reimplemented from Gyoto::Object.

## getTransmission() [1/2]

double const * Gyoto::Photon::getTransmission | ( |  | ) | const

inherited

Get Photon::transmission_.

getTansmission()[i] == getTransmission(size_t i)

## getTransmission() [2/2]

double Gyoto::Photon::getTransmission | ( | size_t | i | ) | const

inherited

Get transmission.

Get either Photon::transmission_freqobs_ (with i=-1) or Photon::transmission_[i].

Parameters

  i | channel number of the requested frequency, -1 for Photon::freq_obs_.

## getTransmissionMatrix() [1/2]

Eigen::Matrix4d const * Gyoto::Photon::getTransmissionMatrix | ( |  | ) | const

inherited

Get Photon::transmissionMatrix_.

getTansmissionMatrix()[i] == getTransmissionMatrix(size_t i)

## getTransmissionMatrix() [2/2]

Eigen::Matrix4d Gyoto::Photon::getTransmissionMatrix | ( | size_t | i | ) | const

inherited

Get transmission matrix.

Get either Photon::transmission_freqobs_ (with i=-1) or Photon::transmission_[i].

Parameters

  i | channel number of the requested frequency, -1 for Photon::freq_obs_.

## getTransmissionMax()

double Gyoto::Photon::getTransmissionMax | ( |  | ) | const

inherited

Get maximum transmission;.

Get current maximum of all the transmissions, Photon::transmission_freqobs_ or one elements of the Photon::transmission_ array.

## help()

void Gyoto::Object::help | ( |  | ) | const

inherited

Print (to stdout) some help on this class.

Describe all properties that this instance supports.

## hit()

int Gyoto::Photon::hit | ( | Astrobj::Properties * | data = NULL | ) |

inherited

Integrate the geodesic.

Parameters

  [in,out] | data | Optional Astrobj::Properties to fill with observational quantities.

Returns
  1 if object was hit, else 0.

## integ31()

void Gyoto::Worldline::integ31 | ( | bool | integ | ) |

inherited

Set the integrator kind to 3+1 or 4D.

Initialize state_ to use the required geodesic equation.

## integrator()

void Gyoto::Worldline::integrator | ( | std::string const & | type | ) |

inherited

Set the integrator.

Initialize state_ to use the required integrator.

Parameters

  [in] | type | Either "Legacy" or (if GYOTO_HAVE_BOOST_INTEGRATORS) one of "runge_kutta_cash_karp54", "runge_kutta_fehlberg78", "runge_kutta_dopri5", "runge_kutta_cash_karp54_classic"

## isThreadSafe()

virtual bool Gyoto::Object::isThreadSafe | ( |  | ) | const

virtual inherited

Whether this class is thread-safe.

Return True if this object is thread-safe, i.e. if an instance and its clone can be used in parallel threads (in the context of Scenery::raytrace()). Known objects which are not thread-safe include Lorene metrics and everything from the Python plug-in.

The default implementation considers that the class itself is thread safe and recurses into the declared properties to check whether they are safe too. Classes that abide to the Object/Property paradigm and are themselves thread-safe have nothing special to do.

Objects that clone children in their copy constructor that are not declared as properties must take these children into account.

Classes that are never thread-safe must declare it. It acn be easily done using GYOTO_OBJECT_THREAD_SAFETY in the class declaration and GYOTO_PROPERTY_THREAD_UNSAFE in the class definition.

## kind() [1/2]

virtual std::string Gyoto::Object::kind | ( |  | ) | const

virtual inherited

Get kind_.

Reimplemented in Gyoto::Spectrometer::Uniform.

## kind() [2/2]

virtual void Gyoto::Object::kind | ( | const std::string |  | ) |

protected virtual inherited

Set kind_.

kind(const std::string) is protected because, for most Objects, it should not be changed in runtime. Set kind_

## property()

Property const * Gyoto::Object::property | ( | std::string const | pname | ) | const

inherited

Find property by name.

Look into the Property list for a Property whose name (or name_false, for a boolean Property) is pname. Return a const pointer to the first such property found, or NULL if none is found.

## setCst()

void Gyoto::Worldline::setCst | ( | double const * | cst,
|  | size_t const | ncsts )

inherited

Set Metric-specific constants of motion.

The will (re)allocate Worldline::cst_, copy cst into it, and set Worldline::cst_n_.

This is the same as void Worldline:constantsOfMotion(std::vector<double> const cstv) using a C-style array instead of a vector.

## setInitCoord() [1/3]

virtual void Gyoto::Worldline::setInitCoord | ( | const double | coord[8],
|  | int | dir,
|  | double const | Ephi[4],
|  | double const | Etheta[4] )

virtual inherited

Set Initial coordinate.

Set imin_=imax_=i0_, and x[i0]=coord[].

If dir==1, i0_ is set to 0. If dir==-1, i0_ is set to x_size_-1.

If dir==0 and the Worldine has never been computed (i0_==0, imin_==1 and imax_==0), then dir defaults to 1 for a massive particle and -1 for a massless particle.

If dir==0 and the Worldine has already been computed, i0_ is not changed.

Parameters

  coord | new initial coordinates
  dir | direction of integration. 1 for forward integration, -1 for backards integration, 0 for unknown or both
  Ephi | initial value of base vector to parallel-transport. Ignored if parallel_transport_ is false.
  Etheta | initial value of base vector to parallel-transport. Ignored if parallel_transport_ is false.

## setInitCoord() [2/3]

virtual void Gyoto::Worldline::setInitCoord | ( | const double | coord[8],
|  | int | dir = 0 )

virtual inherited

Set Initial coordinate.

Set imin_=imax_=i0_, and x[i0]=coord[].

If dir==1, i0_ is set to 0. If dir==-1, i0_ is set to x_size_-1.

If dir==0 and the Worldine has never been computed (i0_==0, imin_==1 and imax_==0), then dir defaults to 1 for a massive particle and -1 for a massless particle.

If dir==0 and the Worldine has already been computed, i0_ is not changed.

Parameters

  coord | new initial coordinates
  dir | direction of integration. 1 for forward integration, -1 for backards integration, 0 for unknown or both

Reimplemented in Gyoto::Astrobj::StarTrace.

## setInitCoord() [3/3]

virtual void Gyoto::Worldline::setInitCoord | ( | double const | pos[4],
|  | double const | vel[3],
|  | int | dir = 0 )

virtual inherited

Set initial coordinate.

Parameters

  pos | initial 4-position
  vel | initial 3-velocity
  dir | direction of integration

## setInitialCondition() [1/5]

void Gyoto::Worldline::setInitialCondition | ( | SmartPointer< Metric::Generic > | gg,
|  | const double | coord[8],
|  | const int | dir )

inherited

Set or re-set the initial condition prior to integration.

Parameters

  gg | Gyoto::SmartPointer to the Gyoto::Metric in this universe;
  coord | 8 element array containing the initial condition, i.e. the 4-position and the 4-velocity of the Photon at the receiving end;
  dir | direction: 1 for future, -1 for past.

## setInitialCondition() [2/5]

void Gyoto::Worldline::setInitialCondition | ( | SmartPointer< Metric::Generic > | gg,
|  | const double | coord[8],
|  | const int | dir,
|  | double const | Ephi[4],
|  | double const | Etheta[4] )

inherited

Set or re-set the initial condition prior to integration.

Parameters

  gg | Gyoto::SmartPointer to the Gyoto::Metric in this universe;
  coord | 8 element array containing the initial condition, i.e. the 4-position and the 4-velocity of the Photon at the receiving end;
  dir | direction: 1 for future, -1 for past.
  Ephi | initial value of base vector to parallel-transport. Ignored if parallel_transport_ is false.
  Etheta | initial value of base vector to parallel-transport. Ignored if parallel_transport_ is false.

## setInitialCondition() [3/5]

void Gyoto::Photon::setInitialCondition | ( | SmartPointer< Metric::Generic > | gg,
|  | SmartPointer< Astrobj::Generic > | obj,
|  | const double | coord[8] )

inherited

Set or re-set the initial condition prior to integration.

Set initial condition for this Photon. Several versions of this function, with and without base vectors to parallel-transport, are provided. If polarization is to be treated, use the version with the base vectors.

Parameters

  gg | Gyoto::SmartPointer to the Gyoto::Metric in this universe;
  obj | Gyoto::SmartPointer to the target Gyoto::Astrobj;
  coord | 8-element array containing the initial condition, i.e. the 4-position and the 4-velocity of the Photon at the receiving end;

## setInitialCondition() [4/5]

void Gyoto::Photon::setInitialCondition | ( | SmartPointer< Metric::Generic > | gg,
|  | SmartPointer< Astrobj::Generic > | obj,
|  | const double | coord[8],
|  | const double | Ephi[4],
|  | const double | Etheta[4] )

inherited

Set or re-set the initial condition prior to integration.

Set initial condition for this Photon. Several versions of this function, with and without base vectors to parallel-transport, are provided. If polarization is to be treated, use the version with the base vectors. Initialize those vectors to the two base vectors for the Stokes parameters in the observer screen.

Parameters

  gg | Gyoto::SmartPointer to the Gyoto::Metric in this universe;
  obj | Gyoto::SmartPointer to the target Gyoto::Astrobj;
  coord | 8-element array containing the initial condition, i.e. the 4-position and the 4-velocity of the Photon at the receiving end;
  Ephi | initial value of base vector to parallel-transport. Ignored if parallel_transport_ is false.
  Etheta | initial value of base vector to parallel-transport. Ignored if parallel_transport_ is false.

## setInitialCondition() [5/5]

void Gyoto::Photon::setInitialCondition | ( | SmartPointer< Metric::Generic > | gg,
|  | SmartPointer< Astrobj::Generic > | obj,
|  | SmartPointer< Screen > | screen,
|  | double | d_alpha,
|  | double | d_delta )

inherited

Set or re-set the initial condition prior to integration.

Set initial condition for this Photon. This version of this function automatically takes care of initializing the base vectors for polarization when needed.

Parameters

  gg | Gyoto::SmartPointer to the Gyoto::Metric in this universe;
  obj | Gyoto::SmartPointer to the target Gyoto::Astrobj;
  screen | Observer's screen;
  d_alpha | Direction of arrival (RA offset) in radians;
  d_delta | Direction of arrival (Dec offset) in radians.

## setParameter() [1/2]

virtual void Gyoto::Object::setParameter | ( | Gyoto::Property const & | p,
|  | std::string const & | name,
|  | std::string const & | content,
|  | std::string const & | unit )

virtual inherited

Set parameter by Property (and name).

This function is used when parsing an XML description, if Property (p) of this name is found (i.e. either p.name or p.name_false is equal to name). Implementation should fall-back on calling the direct's parent implementation:

class A: public Object {};
class B: public A {
using B::setParameter;
virtual void setParameter(Gyoto::Property const &p,
std::string name,
std::string content,
std::string unit);
};
void B::setParameter(Gyoto::Property const &p,
std::string name,
std::string content,
std::string unit) {
if (name=="Duff") doSomething(content, unit);
else A::setParameter(p, name, content, unit);
}
Gyoto::Object::setParameter
virtual int setParameter(std::string name, std::string content, std::string unit)
Set parameter by name.

Parameters

  p | Property that matches name (p.name == name or p.name_false == name)
  name | XML name of the parameter (XML entity)
  content | string representation of the value
  unit | string representation of the unit

Reimplemented in Gyoto::Astrobj::PolishDoughnut.

## setParameter() [2/2]

virtual int Gyoto::Object::setParameter | ( | std::string | name,
|  | std::string | content,
|  | std::string | unit )

virtual inherited

Set parameter by name.

This function is used when parsing an XML description, if no Property of this name is found. Overriding implementation should fall-back on calling the direct's parent implementation:

class A: public Object {};
class B: public A {
using B::setParameter;
virtual int setParameter(std::string name,
std::string content,
std::string unit);
};
int B::setParameter(std::string name,
std::string content,
std::string unit) {
if (name=="Duff") doSomething(content, unit);
else return A::setParameter(name, content, unit);
return 0; // name was known
}

Parameters

  name | XML name of the parameter (XML entity). This may have a path component, e.g. "Astrobj::Radius", in which case a property named "Astrobj" will be sought in the current object, and setParameter will be called recusrively on this Astrobj with Radius as name.
  content | string representation of the value
  unit | string representation of the unit

Returns
  0 if this parameter is known, 1 if it is not.

Reimplemented in Gyoto::Astrobj::EquatorialHotSpot, Gyoto::Astrobj::Star, Gyoto::Metric::KerrKS, and Gyoto::Metric::RotStar3_1.

## setParameters()

virtual void Gyoto::Photon::setParameters | ( | FactoryMessenger * | fmp | ) |

virtual inherited

Main loop for parsing Properties from XML description.

    This function queries the FactoryMessenger for elements to parse,
    and tries to matche each element to a Property to set it
    accordingly.

    Any class that tries to be buildable from XML must supply a
    subcontractor (for base classes such as Metric, Astrobj, Spectrum
    and Spectrometer, it is done as a template that must be
    specialized for each class).

    This subcontractor typically looks somewhat like this:

SmartPointer<Metric::Generic>
Gyoto::Metric::MyKind::Subcontractor(FactoryMessenger* fmp) {
SmartPointer<MyKind> gg = new MyKind();
gg -> setParameters(fmp);
return gg;
}
Gyoto::Photon::setParameters
virtual void setParameters(FactoryMessenger *fmp)
Main loop for parsing Properties from XML description.
Gyoto::SmartPointer
Pointers performing reference counting.
Definition GyotoSmartPointer.h:135

    Although this is discouraged, it is possible to override the
    following functions to customize how XML entities are parsed:
      - setParameters() if low-level access to the
        FactoryMessenger is required;
      - setParameter(std::string name,
                     std::string content,
                     std::string unit)
        to interpret an entity that does not match a Property
        (e.g. alternative name);
      - setParameter(Gyoto::Property const &p,
                     std::string const &name,
                     std::string const &content,
                     std::string const &unit)
        to change how a Property is interpreted.

Reimplemented from Gyoto::Object.

## tell()

virtual void Gyoto::Worldline::tell | ( | Gyoto::Hook::Teller * | msg | ) |

protected virtual inherited

This is how a Teller tells.

A teller will basically call listener->tell(this).

Parameters

  msg | Teller* the Teller who is telling... Useful if the Listener listens to several Tellers.

Reimplemented from Gyoto::Hook::Listener.

## transfer()

virtual void Gyoto::Photon::Refined::transfer | ( | double * | Inu,
|  | double * | Qnu,
|  | double * | Unu,
|  | double * | Vnu,
|  | Eigen::Matrix4d * | Onu )

virtual

Perform one step of polarized radiative transfert and update transmission matrix.

Reimplemented from Gyoto::Photon.

## transmit() [1/2]

virtual void Gyoto::Photon::Refined::transmit | ( | size_t | i,
|  | double | t )

virtual

Update transmission both in *this and in *parent_.

Reimplemented from Gyoto::Photon.

## transmit() [2/2]

virtual void Gyoto::Photon::Refined::transmit | ( | size_t | i,
|  | Eigen::Matrix4d | mat )

virtual

Update transmission Matrix both in *this and in *parent_.

Reimplemented from Gyoto::Photon.

## xAllocate() [1/2]

virtual void Gyoto::Worldline::xAllocate | ( |  | ) |

protected virtual inherited

Allocate x0, x1 etc. with default size.

The default size is GYOTO_DEFAULT_X_SIZE

## xAllocate() [2/2]

virtual void Gyoto::Worldline::xAllocate | ( | size_t | size | ) |

protected virtual inherited

Allocate x0, x1 etc. with a specified size.

Parameters

  size | : number of cells in each array x0, x1 etc.

Reimplemented in Gyoto::Astrobj::StarTrace.

## xExpand() [1/2]

virtual void Gyoto::Worldline::xExpand | ( | double *& | x,
|  | int | dir )

protected virtual inherited

Expand one array to hold more elements.

If you need to expand more arrays than x0_ ... x3_ and the dots, call this on your array before calling xExpand(int dir).

Parameters

  [in,out] | x | array to expand
  [in] | dir |

## xExpand() [2/2]

virtual size_t Gyoto::Worldline::xExpand | ( | int | dir | ) |

protected virtual inherited

Expand x0, x1 etc... to hold more elements.

Double the size of arrays x0, x1 etc. and copy old version of the array in the first half if dir =1 and in the second half if dir =-1.

Parameters

  dir | : 1 to expand after last element, -1 to expand before first element

Returns
  ind : if dir=1, new index of old last element, if dir=-1, new index of old first element

Reimplemented in Gyoto::Astrobj::StarTrace.

## xStore()

virtual void Gyoto::Worldline::xStore | ( | size_t | ind,
|  | state_t const & | coord,
|  | double | tau )

virtual inherited

Store coord at index ind.

Reimplemented in Gyoto::Astrobj::StarTrace.

## Member Data Documentation

## abstol_

double Gyoto::Worldline::abstol_

protected inherited

Absolute tolerance of the integrator.

Used by the adaptive integrators implemented in IntegState::Boost. Refer to the boost::numeric::odeint documentation for more details.

## delta_

double Gyoto::Worldline::delta_

protected inherited

Initial integrating step.

Default: GYOTO_DEFAULT_DELTA

## delta_max_

double Gyoto::Worldline::delta_max_

protected inherited

Maximum integration step for the adaptive integrator.

The default (GYOTO_DEFAULT_DELTA_MAX) is usually fine.

For IntegState::Legacy, set it in the Metric instead!

## delta_max_over_r_

double Gyoto::Worldline::delta_max_over_r_

protected inherited

Numerical tuning parameter.

For IntegState::Legacy, set it in the Metric instead!

Ensure that delta (the numerical integration step) is never larger than a fraction of the distance between the current location and the center of the coordinate system.

The default (GYOTO_DEFAULT_DELTA_MAX_OVER_R) is usually fine.

## delta_min_

double Gyoto::Worldline::delta_min_

protected inherited

Minimum integration step for the adaptive integrator.

The default (GYOTO_DEFAULT_DELTA_MIN) is usually fine.

For IntegState::Legacy, set it in the Metric instead!

## freq_obs_

double Gyoto::Photon::freq_obs_

protected inherited

Photon's frequency in observer's frame.

In Hz, for quantity Emission

## kind_

std::string Gyoto::Object::kind_

protected inherited

The "kind" that is output in the XML entity.

E.g. for an Astrobj, fillElement() will ensure

<Astrobj kind="kind_" ...>...</Astrobj>
Gyoto::Object::kind
virtual void kind(const std::string)
Set kind_.
Gyoto::Astrobj
Access to astronomical objects.
Definition GyotoAstrobj.h:49

is written.

## maxCrossEqplane_

double Gyoto::Worldline::maxCrossEqplane_

protected inherited

Maximum number of crossings of equatorial plane.

Used to determine how much higher-order image features should be kept.

## mutex_

pthread_mutex_t Gyoto::SmartPointee::mutex_

private inherited

A mutex.

When compiled with libpthread

## object_

SmartPointer<Gyoto::Astrobj::Generic> Gyoto::Photon::object_

protected inherited

The astronomical target.

The (only) possible origin for this Photon.

## parallel_transport_

bool Gyoto::Worldline::parallel_transport_

protected inherited

Whether to parallel transport a local triad.

Typically used to trace the base in which the Stokes parameters are expressed in the context of polarization.

## plugins_

std::vector<std::string> Gyoto::Object::plugins_

protected inherited

The plug-ins that needs to be loaded to access this instance's class.

E.g. for an Astrobj, fillElement() will ensure

<Astrobj ... plugin="plugins_">...</Astrobj>

is written.

## reltol_

double Gyoto::Worldline::reltol_

protected inherited

Absolute tolerance of the integrator.

Used by the adaptive integrators implemented in IntegState::Boost. Refer to the boost::numeric::odeint documentation for more details.

## secondary_

bool Gyoto::Worldline::secondary_

protected inherited

Experimental: choose 0 to compute only primary image.

This feature is in development.

## spectro_

SmartPointer<Spectrometer::Generic> Gyoto::Photon::spectro_

protected inherited

Observer's spectrometer.

Conveying observation frequencies for quantities Spectrum and BinSpectrum.

## tmin_

double Gyoto::Worldline::tmin_

protected inherited

Time limit for the integration (geometrical units).

Computation does not go back before tmin_. Default is -DBL_MAX. tmin_ is always expressed in geometrical units, it is essentially a tuning parameter for the ray-tracing process. tmin_ should be chosen to always be longer than the distance between the screen and the object.

## transmission_

double* Gyoto::Photon::transmission_

protected inherited

Integrated optical transmissions.

For each frequency in Photon::spectro_->getMidpoints(), between current position and observer.

## transmission_freqobs_

double Gyoto::Photon::transmission_freqobs_

protected inherited

Integrated optical transmission.

At Photon::freq_obs_, between current position and observer.

## transmissionMatrix_

Eigen::Matrix4d* Gyoto::Photon::transmissionMatrix_

protected inherited

Integrated optical transmission matrix (polarization).

For each frequency in Photon::spectro_->getMidpoints(), between current position and observer.

## transmissionMatrix_freqobs_

Eigen::Matrix4d Gyoto::Photon::transmissionMatrix_freqobs_

protected inherited

Integrated optical transmission matrix (polarization).

At Photon::freq_obs_, between current position and observer.

## x_size_

size_t Gyoto::Worldline::x_size_

protected inherited

Coordinate of Second base vector to parallel transport.

Size of x0_, x1_... arrays

The documentation for this class was generated from the following file:

- GyotoPhoton.h